/*****************************************************************************
 * file    include/main.h 
 * author  YuLiang
 * version 1.0.0
 * date    26-Sep-2021
 * brief   This file provides all the headers of the main functions.
 ******************************************************************************
 * Attention
 *
 * <h2><center>&copy; COPYRIGHT(c) 2021 LandPower</center></h2>
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *   1. Redistributions of source code must retain the above copyright notice,
 *      this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright notice,
 *      this list of conditions and the following disclaimer in the documentation
 *      and/or other materials provided with the distribution.
 *   3. Neither the name of LandPower nor the names of its contributors may be used to 
 *      endorse or promote products derived from this software without specific
 *      prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 ******************************************************************************/

#ifndef __PROCESS_H__
#define __PROCESS_H__

/* Includes ------------------------------------------------------------------*/

/* Define --------------------------------------------------------------------*/

/* Exported types ------------------------------------------------------------*/
/* 消息队列类型. */
typedef enum
{
    MSG_TYPE_DAU_RECV = 5,                      /* 1-4 固定被 DAU 发送线程使用, 这里从 5 开始. */
    MSG_TYPE_COUNT,
} MSG_TYPE_E;

/* 系统复位类型 */
typedef enum _REBOOT_MSG
{
    REBOOT_NONE = 0,
    REBOOT_LOCAL_SERVER_IP_CHANGE,
    REBOOT_LOCAL_IP_CHANGE,
    REBOOT_LOCAL_HOST_NAME_CHANGE,
    REBOOT_LOCAL_RESET,
    REBOOT_LOCAL_ARM_UPGRADE,
    REBOOT_REMOTE_SERVER_IP_CHANGE,
    REBOOT_REMOTE_IP_CHANGE,
    REBOOT_REMOTE_HOST_NAME_CHANGE,
    REBOOT_REMOTE_RESET,
    REBOOT_UPGRADE_ALL,
    REBOOT_SYSTEM_RESET,
    REBOOT_4G_ERROR,
    REBOOT_NET_ERROR,
    REBOOT_MAX,
} REBOOT_MSG;

typedef struct 
{
    REBOOT_MSG type;    // 重启类型
    char *msg;          // 重启日志
} reboot_msg_t;

/* Extern global variables ---------------------------------------------------*/
extern int32_t recv_qid;
extern uint16_t version_hex;
extern uint32_t start_time;

/* Exported macro ------------------------------------------------------------*/

/* Exported functions --------------------------------------------------------*/
extern void reboot_system(int module, REBOOT_MSG type);
#endif
/************************ (C) COPYRIGHT LandPower ***** END OF FILE ****/
